<?php
$lang->kanban->common               = '看板';
$lang->kanban->browse               = '瀏覽';
$lang->kanban->browseArchivedTask   = '已歸檔任務';
$lang->kanban->browseArchivedColumn = '已歸檔看板列';
$lang->kanban->createRegion         = '新增區域';
$lang->kanban->editRegion           = '編輯區域';
$lang->kanban->sortRegion           = '區域排序';
$lang->kanban->deleteRegion         = '刪除區域';
$lang->kanban->sortGroup            = '看板組排序';
$lang->kanban->createLane           = '新增泳道';
$lang->kanban->editLane             = '編輯泳道';
$lang->kanban->sortLane             = '泳道排序';
$lang->kanban->deleteLane           = '刪除泳道';
$lang->kanban->createColumn         = '添加看板列';
$lang->kanban->copyColumn           = '複製看板列';
$lang->kanban->editColumn           = '編輯看板列';
$lang->kanban->splitColumn          = '看板列拆分子列';
$lang->kanban->archiveColumn        = '歸檔看板列';
$lang->kanban->restoreColumn        = '還原看板列';
$lang->kanban->deleteColumn         = '刪除看板列';
$lang->kanban->sortItem             = '任務排序';
$lang->kanban->addItem              = '添加任務';
$lang->kanban->restore              = '還原';
$lang->kanban->restoring            = '還原中';
$lang->kanban->archive              = '歸檔';
$lang->kanban->archiving            = '歸檔中';
$lang->kanban->createColumnOnLeft   = '在左側添加看板列';
$lang->kanban->createColumnOnRight  = '在右側添加看板列';
$lang->kanban->createTask           = '添加任務';
$lang->kanban->columnStatus         = '看板列任務狀態設置';
$lang->kanban->columnOrder          = '看板列任務排序';
$lang->kanban->browseDeleted        = '已刪除任務';
$lang->kanban->fullScreen           = '全屏展示';
$lang->kanban->WIP                  = '在製品數量(WIP)';
$lang->kanban->limitExceeded        = '超出在製品限制';
$lang->kanban->unlimited            = '不限制';
$lang->kanban->before               = '前';
$lang->kanban->after                = '後';
$lang->kanban->child                = '子';

$lang->kanban->archivedTask   = '已歸檔的任務';
$lang->kanban->archivedColumn = '已歸檔的看板列';
$lang->kanban->defaultRegion  = '預設區域';
$lang->kanban->defaultLane    = '預設泳道';
$lang->kanban->deadline       = '截止';

$lang->kanban->placeholder = new stdclass();
$lang->kanban->placeholder->inputColumnName = '請輸入看板列名稱';
$lang->kanban->placeholder->inputTaskName   = '請輸入任務標題';
$lang->kanban->placeholder->inputTaskDesc   = '請輸入任務描述';
$lang->kanban->placeholder->inputLaneName   = '請輸入泳道名稱';

$lang->kanban->error = new stdclass();
$lang->kanban->error->limitError      = '父列總在製品限制要大於或等於子列在製品限制';
$lang->kanban->error->childLimitError = '子列總在製品限制不能大於父列在製品限制';

$lang->kanbanregion = new stdclass();
$lang->kanbanregion->common              = '看板區域';
$lang->kanbanregion->name                = '區域名稱';
$lang->kanbanregion->order               = '區域排序';
$lang->kanbanregion->confirmDelete       = '您確定要刪除該區域嗎？';
$lang->kanbanregion->confirmDeleteDetail = '刪除該區域後，該區域中所有數據將會被刪除。';

$lang->kanbanlane = new stdclass();
$lang->kanbanlane->common              = '泳道';
$lang->kanbanlane->group               = '看板組';
$lang->kanbanlane->order               = '泳道排序';
$lang->kanbanlane->name                = '泳道名稱';
$lang->kanbanlane->column              = '泳道看板列';
$lang->kanbanlane->otherlane           = '選擇共享看板列的泳道';
$lang->kanbanlane->color               = '泳道顏色';
$lang->kanbanlane->confirmDelete       = '您確定要刪除該泳道嗎？';
$lang->kanbanlane->confirmDeleteDetail = '刪除泳道後，該泳道中所有數據（看板列、任務）將會被刪除。';

$lang->kanbanlane->modeList['sameAsOther'] = '與其他泳道使用相同看板列';
$lang->kanbanlane->modeList['independent'] = '採用獨立的看板列';

$lang->kanbancolumn = new stdclass();
$lang->kanbancolumn->common               = '看板列';
$lang->kanbancolumn->name                 = '看板列名稱';
$lang->kanbancolumn->group                = '看板組';
$lang->kanbancolumn->order                = '看板列排序';
$lang->kanbancolumn->limit                = '在製品數量(WIP)';
$lang->kanbancolumn->color                = '看板列顏色';
$lang->kanbancolumn->position             = '看板列位置';
$lang->kanbancolumn->copyItems            = '複製看板列卡片';
$lang->kanbancolumn->childName            = '子列名稱';
$lang->kanbancolumn->childColor           = '子列顏色';
$lang->kanbancolumn->archived             = '歸檔狀態';
$lang->kanbancolumn->archivedBy           = '由誰歸檔';
$lang->kanbancolumn->archivedDate         = '歸檔時間';
$lang->kanbancolumn->confirmArchive       = '您確定要歸檔該看板列嗎？';
$lang->kanbancolumn->confirmArchiveDetail = '歸檔看板列後，該看板列和看板列中所有的任務將被隱藏，您可以到看板設置中查看已歸檔的看板列。';
$lang->kanbancolumn->confirmRestore       = '您確定要還原該看板列嗎？';
$lang->kanbancolumn->confirmRestoreDetail = '還原看板列後，該看板列和看板列中所有的任務將同時還原到之前的位置。';
$lang->kanbancolumn->confirmDelete        = '您確定要刪除該看板列嗎？';
$lang->kanbancolumn->confirmDeleteDetail  = '刪除該看板列後，該看板列中所有任務將會被刪除。';

$lang->kanbanColumn->copyItemsStatus['1'] = '是';
$lang->kanbanColumn->copyItemsStatus['0'] = '否';
